View a markdown version of this page

CreateAgentOrganizationalProfile - AWS Well-Architected

CreateAgentOrganizationalProfile

Important

This operation is not available during the preview release.

Creates an Organizational Profile for use with AWS Organizations integration. Organizational Profiles are scoped to an AWS Organization and do not require an execution role or aggregation configuration. The organization is inferred from the caller's identity.

Request Syntax

POST /api/v1/agent-organizational-profiles HTTP/1.1 Content-type: application/json { "businessOverview": "string", "clientToken": "string", "deletionProtection": boolean, "description": "string", "displayName": "string", "name": "string", "organizationalAggregationConfiguration": { "accounts": [ { "accountId": "string", "regions": [ "string" ] } ], "organizationalUnits": [ { "organizationalUnitId": "string", "regions": [ "string" ] } ] }, "pillars": [ "string" ], "tags": [ { "key": "string", "value": "string" } ] }

URI Request Parameters

The request does not use any URI parameters.

Request Body

The request accepts the following data in JSON format.

businessOverview

The business overview for this organizational profile.

Type: String

Length Constraints: Minimum length of 0. Maximum length of 512.

Pattern: (?:(?!\$\{[a-zA-Z]+:)[\P{C}])*

Required: No

clientToken

A unique, case-sensitive identifier that you provide to ensure the idempotency of the request.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 128.

Pattern: [\x21-\x7E]+

Required: No

deletionProtection

Indicates whether deletion protection is enabled for the organizational profile.

Type: Boolean

Required: No

description

A description of the organizational profile.

Type: String

Length Constraints: Minimum length of 0. Maximum length of 512.

Pattern: (?:(?!\$\{[a-zA-Z]+:)[\P{C}])*

Required: No

displayName

The display name of the organizational profile shown to users.

Type: String

Length Constraints: Minimum length of 3. Maximum length of 128.

Pattern: (?:(?!\$\{[a-zA-Z]+:)[\P{C}])+

Required: No

name

The system name of the organizational profile.

Type: String

Length Constraints: Minimum length of 3. Maximum length of 128.

Pattern: [a-zA-Z0-9_-]+

Required: Yes

organizationalAggregationConfiguration
Important

This is not available during the preview release.

The organizational monitoring boundary. Contains organizational unit or root entries and individual account entries that define the scope for the profile.

Type: OrganizationalAggregationConfiguration object

Required: No

pillars

The AWS Well-Architected Framework pillars to associate with this organizational profile.

Type: Array of strings

Array Members: Minimum number of 1 item. Maximum number of 5 items.

Valid Values: COST_OPTIMIZATION | SECURITY | RESILIENCE | PERFORMANCE | OPERATIONAL_EXCELLENCE

Required: Yes

tags

The tags to associate with the organizational profile.

Type: Array of Tag objects

Required: No

Response Syntax

HTTP/1.1 200 Content-type: application/json { "arn": "string", "businessOverview": "string", "createdAt": "string", "createdBy": "string", "deletionProtection": boolean, "description": "string", "displayName": "string", "eligibleForArchitectureGeneration": boolean, "eligibleForScheduledGeneration": boolean, "fieldErrors": { "string" : "string" }, "lastModifiedAt": "string", "lastModifiedBy": "string", "name": "string", "organizationalAggregationConfiguration": { "accounts": [ { "accountId": "string", "regions": [ "string" ] } ], "organizationalUnits": [ { "organizationalUnitId": "string", "regions": [ "string" ] } ] }, "organizationId": "string", "pillars": [ "string" ], "tags": [ { "key": "string", "value": "string" } ] }

Response Elements

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

arn

The Amazon Resource Name (ARN) of the created organizational profile.

Type: String

Length Constraints: Minimum length of 0. Maximum length of 2048.

Pattern: arn:aws([a-z0-9-]+)?:wellarchitected:[a-z0-9-]{6,64}:\d{12}:agent-profile/([a-zA-Z0-9_-]+)

businessOverview

The business overview of the created organizational profile.

Type: String

Length Constraints: Minimum length of 0. Maximum length of 512.

Pattern: (?:(?!\$\{[a-zA-Z]+:)[\P{C}])*

createdAt

The timestamp when the organizational profile was created.

Type: Timestamp

createdBy

The identifier of the user or system that created this organizational profile.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 128.

deletionProtection

Indicates whether deletion protection is enabled.

Type: Boolean

description

A description of the created organizational profile.

Type: String

Length Constraints: Minimum length of 0. Maximum length of 512.

Pattern: (?:(?!\$\{[a-zA-Z]+:)[\P{C}])*

displayName

The display name of the created organizational profile.

Type: String

Length Constraints: Minimum length of 3. Maximum length of 128.

Pattern: (?:(?!\$\{[a-zA-Z]+:)[\P{C}])+

eligibleForArchitectureGeneration

Indicates whether the profile is valid for manual architecture generation.

Type: Boolean

eligibleForScheduledGeneration

Indicates whether the profile is valid for scheduled recommendation generation.

Type: Boolean

fieldErrors

A map of field paths to error messages for invalid or missing input fields.

Type: String to string map

Map Entries: Minimum number of 0 items. Maximum number of 100 items.

Key Length Constraints: Minimum length of 1. Maximum length of 256.

Value Length Constraints: Minimum length of 1. Maximum length of 1024.

lastModifiedAt

The timestamp when the organizational profile was last modified.

Type: Timestamp

lastModifiedBy

The identifier of the user or system that last modified this organizational profile.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 128.

name

The system name of the created organizational profile.

Type: String

Length Constraints: Minimum length of 3. Maximum length of 128.

Pattern: [a-zA-Z0-9_-]+

organizationalAggregationConfiguration
Important

This is not available during the preview release.

The organizational monitoring boundary for the created profile. Present only for organizational profiles.

Type: OrganizationalAggregationConfiguration object

organizationId

The identifier of the AWS Organization this profile belongs to.

Type: String

pillars

The AWS Well-Architected Framework pillars associated with the created organizational profile.

Type: Array of strings

Array Members: Minimum number of 1 item. Maximum number of 5 items.

Valid Values: COST_OPTIMIZATION | SECURITY | RESILIENCE | PERFORMANCE | OPERATIONAL_EXCELLENCE

tags

The tags associated with the created organizational profile.

Type: Array of Tag objects

Errors

For information about the errors that are common to all actions, see Common Error Types.

AccessDeniedException

User does not have sufficient access to perform this action.

Message

Description of the error.

HTTP Status Code: 403

ConflictException

The resource has already been processed, was deleted, or is too large.

Message

Description of the error.

ResourceId

Identifier of the resource affected.

ResourceType

Type of the resource affected.

HTTP Status Code: 409

InternalServerException

There is a problem with the AWS Well-Architected Tool API service.

Message

Description of the error.

HTTP Status Code: 500

ResourceNotFoundException

The requested resource was not found.

Message

Description of the error.

ResourceId

Identifier of the resource affected.

ResourceType

Type of the resource affected.

HTTP Status Code: 404

ServiceQuotaExceededException

The user has reached their resource quota.

Message

Description of the error.

QuotaCode

Service Quotas requirement to identify originating quota.

ResourceId

Identifier of the resource affected.

ResourceType

Type of the resource affected.

ServiceCode

Service Quotas requirement to identify originating service.

HTTP Status Code: 402

ThrottlingException

Request was denied due to request throttling.

Message

Description of the error.

QuotaCode

Service Quotas requirement to identify originating quota.

ServiceCode

Service Quotas requirement to identify originating service.

HTTP Status Code: 429

ValidationException

The user input is not valid.

Fields

The fields that caused the error, if applicable.

Message

Description of the error.

Reason

The reason why the request failed validation.

HTTP Status Code: 400

See Also

For more information about using this API in one of the language-specific AWS SDKs, see the following: